import { getRepository } from "typeorm";
import { DeadChatReply } from "@db/entity/DeadChatReply";
import { CommandSet, Action, ActionType } from "src/model/command";
import { Message } from "discord.js";

const triggers = [
    "dead server",
    "dead chat",
    "ded chat",
    "ded server"
];

@CommandSet
export class DeadChat {
    @Action(ActionType.MESSAGE)
    async onMessage(actionsDone: boolean, msg: Message, content: string) {
        if (actionsDone)
            return false;

        let lowerContent = content.toLowerCase();

        if (!triggers.some(s => lowerContent.includes(s)))
            return false;

        let repo = getRepository(DeadChatReply);

        let reply = await repo.query(`  select message
                                        from dead_chat_reply
                                        order by random()
                                        limit 1`) as DeadChatReply[];

        if (reply.length == 0)
            return false;

        msg.channel.send(reply[0].message);

        return true;
    }
};